/*
	File:		EI_Codec.c
	
	Description: Compressor component for Electric Image files

	Author:		??

	Copyright: 	 Copyright 1999 Apple Computer, Inc. All rights reserved.
	
	Disclaimer:	IMPORTANT:  This Apple software is supplied to you by Apple Computer, Inc.
				("Apple") in consideration of your agreement to the following terms, and your
				use, installation, modification or redistribution of this Apple software
				constitutes acceptance of these terms.  If you do not agree with these terms,
				please do not use, install, modify or redistribute this Apple software.

				In consideration of your agreement to abide by the following terms, and subject
				to these terms, Apple grants you a personal, non-exclusive license, under Apples
				copyrights in this original Apple software (the "Apple Software"), to use,
				reproduce, modify and redistribute the Apple Software, with or without
				modifications, in source and/or binary forms; provided that if you redistribute
				the Apple Software in its entirety and without modifications, you must retain
				this notice and the following text and disclaimers in all such redistributions of
				the Apple Software.  Neither the name, trademarks, service marks or logos of
				Apple Computer, Inc. may be used to endorse or promote products derived from the
				Apple Software without specific prior written permission from Apple.  Except as
				expressly stated in this notice, no other rights or licenses, express or implied,
				are granted by Apple herein, including but not limited to any patent rights that
				may be infringed by your derivative works or by other works in which the Apple
				Software may be incorporated.

				The Apple Software is provided by Apple on an "AS IS" basis.  APPLE MAKES NO
				WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
				WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
				PURPOSE, REGARDING THE APPLE SOFTWARE OR ITS USE AND OPERATION ALONE OR IN
				COMBINATION WITH YOUR PRODUCTS.

				IN NO EVENT SHALL APPLE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR
				CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
				GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
				ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION
				OF THE APPLE SOFTWARE, HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT
				(INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF APPLE HAS BEEN
				ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
				
	Change History (most recent first):

	   <1>	 	11/28/99	???		first file

*/

#define SystemSevenOrLater 1
#define UseExtendedThingResource 1

#include "ConditionalMacros.r"
#include "MacTypes.r"
#include "Components.r"
#include "ImageCodec.r"

#include "EI_CodecVersion.h"

#define	kEI_CodecFormatType	'EIDI'
#define	kEI_CodecFormatName	"Electric Image"

#define kEI_DecoFlags		( codecInfoDoes32 | codecInfoDoes16 | codecInfoDoes8 | codecInfoDoes1 )
#define kEI_FormatFlags		( codecInfoDepth32 | codecInfoDepth24 | codecInfoDepth16 | codecInfoDepth8 | codecInfoDepth1 )

resource 'cdci' (256) {
	kEI_CodecFormatName,
	1,
	1,
	'appl',
	kEI_DecoFlags,
	0,
	kEI_FormatFlags,
	128,
	128,
	200,
	200,
	128,
	0,
	1,
	1,
	0,
	0,
	0
};

resource 'thng' (256) {
	decompressorComponentType,
	'EIDI',
	'appl',
#if	TARGET_REZ_MAC_68K
	kEI_DecoFlags,
	0,
	'cdec',	256,	// Code
#else
	0,		0,		// Flags, Mask
	0,		0,		// Code
#endif
	'STR ',	256,	// Name
	'STR ',	257,	// Info
	0,	0,			// Icon
#if TARGET_REZ_MAC_PPC
	kEI_CodecVersionPPC,
#else
	kEI_CodecVersion,
#endif

#if !TARGET_REZ_MAC_68K
	componentHasMultiplePlatforms + 
#endif
		componentDoAutoVersion,
	0,
	{
#if	TARGET_REZ_MAC_PPC
		kEI_DecoFlags, 
		'cdek',
		256,
		platformPowerPC,
#elif	!TARGET_OS_MAC
		kEI_DecoFlags, 
		'dlle',
		256,
		Target_PlatformType
#endif
	};
};

resource 'STR ' (256) {
	"Electric Image"
};

resource 'STR ' (257) {
	"Decompressors images stored in the Electric Image format."
};

#if	!TARGET_OS_MAC
	resource 'dlle' (256) {
		"EI_CDComponentDispatch"
	};
#endif
