/*
	File:		ExportMovie.c
	
	Contains:	QuickTime sample code

	Copyright:	 2000 by Apple Computer, Inc. All rights reserved


*/

#include <Script.h>
#include "ExportMovie.h"

void SimpleExportMovie(Movie theMovie, FSSpec *theFSSpec)
{
	long exportFlags = showUserSettingsDialog |
					   movieToFileOnlyExport |
					   movieFileSpecValid |
					   createMovieFileDeleteCurFile;

	// If the movie is currently playing stop it
	if (GetMovieRate(theMovie))
		StopMovie(theMovie);

	// use the default progress procedure, if any
	SetMovieProgressProc(theMovie,					// the movie specifier
						 (MovieProgressUPP)-1L,		// pointer to a progress function; -1 indicades default
						 0);						// reference constant
	
	// export the movie into a file
	ConvertMovieToFile(theMovie,					// the movie to convert
					   NULL,						// all tracks in the movie
					   theFSSpec,					// the output file
					   0,							// the output file type
					   0,							// the output file creator
					   smSystemScript,				// the script
					   NULL, 						// no resource ID to be returned
					   exportFlags,					// no flags
					   NULL);						// no specific component
}