#ifndef __SEQUENCEGRAB__
	#define __SEQUENCEGRAB__

// build for carbon
#ifndef TARGET_API_MAC_CARBON
	#define TARGET_API_MAC_CARBON 1
#endif

// includes
#include <Gestalt.h>
#include <ConditionalMacros.h>
#include <Movies.h>
#include <QuickTimeComponents.h>
#include <Script.h>
#include <FileTypesAndCreators.h>
#include <Navigation.h>

#if TARGET_OS_MAC
	#define PASCAL_RTN pascal
#else
	#define PASCAL_RTN
#endif

#if TARGET_OS_MAC
	typedef WindowPtr			WindowReference;
#endif

#if TARGET_OS_WIN32
	typedef HWND				WindowReference;
#endif

const StringPtr kApplicationName = "\pSequenceGrab";

// prototypes
Boolean IsQuickTimeInstalled(void);
WindowRef MakeAWindow(void);
SeqGrabComponent MakeSequenceGrabber(WindowPtr pMacWnd);
void MakeSequenceGrabChannels(SeqGrabComponent seqGrab, SGChannel *sgchanVideo, SGChannel *sgchanSound, const Rect *rect, Boolean bWillRecord);
OSErr SetupVideoBottlenecks(SGChannel sgchanVideo, CGrafPtr pTempPort);
OSErr DoRecord(SeqGrabComponent seqGrab);
PASCAL_RTN ComponentResult GrabFrameCompleteProc(SGChannel sgChan, short nBufferNum, Boolean *pbDone, long lRefCon);
OSErr PutFile(ConstStr255Param thePrompt, ConstStr255Param theFileName, FSSpecPtr theFSSpecPtr, Boolean *theIsSelected, Boolean *theIsReplacing);
PASCAL_RTN void HandleNavEvent (NavEventCallbackMessage theCallBackSelector, NavCBRecPtr theCallBackParms, void *theCallBackUD);

#endif // __SEQUENCEGRAB__